(function(){
  var React, createFactory, createElement, ref$, a, button, div, form, h1, h2, img, input, li, ol, option, span, ul, domRender, Map, Set, List, immutable, classes, sodom, _, FlyingContext, AnilistClass, Anilist;
  React = require('react'), createFactory = React.createFactory, createElement = React.createElement, ref$ = React.DOM, a = ref$.a, button = ref$.button, div = ref$.div, form = ref$.form, h1 = ref$.h1, h2 = ref$.h2, img = ref$.img, input = ref$.input, li = ref$.li, ol = ref$.ol, option = ref$.option, span = ref$.span, ul = ref$.ul;
  domRender = require('react-dom').render;
  ref$ = require('immutable'), Map = ref$.Map, Set = ref$.Set, List = ref$.List, immutable = ref$.fromJS;
  classes = require('./reactex').classes;
  sodom = require('./sodom');
  _ = require('lodash');
  FlyingContext = (function(){
    FlyingContext.displayName = 'FlyingContext';
    var prototype = FlyingContext.prototype, constructor = FlyingContext;
    FlyingContext.prototype.animationsCount = 0;
    FlyingContext.prototype.rects = Map().asMutable();
    function FlyingContext(items, oldItems, before, after){
      var oldItemsReg, ref$, nkeys, okeys, this$ = this;
      this.before = before;
      this.after = after;
      oldItemsReg = Map(oldItems.map(function(it){
        return [it.get('id'), it];
      }));
      ref$ = [items, oldItems].map(compose$(function(it){
        return it.map(function(it){
          return it.get('id');
        });
      }, Set)), nkeys = ref$[0], okeys = ref$[1];
      this.added = nkeys.subtract(okeys);
      this.removed = okeys.subtract(nkeys);
      this.moved = nkeys.subtract(this.added).subtract(this.removed);
      this.items = items.concat(List().withMutations(function(list){
        this$.removed.forEach(function(it){
          return list.push(oldItemsReg.get(it));
        });
        return list;
      }));
    }
    return FlyingContext;
  }());
  AnilistClass = React.createClass({
    displayName: 'AniList',
    getInitialState: function(){
      this.children = Map().asMutable();
      return {
        items: null
      };
    },
    animationsInit: function(items, oldItems){
      this.ctx = new FlyingContext(items, oldItems, bind$(this, 'animationsBefore'), bind$(this, 'animationsAfter'));
      this.setState({
        items: this.ctx.items
      });
    },
    animationsBefore: function(){
      var ref$, removed, moved, added, this$ = this;
      ref$ = this.ctx, removed = ref$.removed, moved = ref$.moved, added = ref$.added;
      this.children.forEach(function(c, id){
        return this$.ctx.rects.set(id, c.getFrame());
      });
    },
    animationsAfter: function(nulled){
      var ref$, added, moved, removed, callAnimationMakers, x$, ans, this$ = this;
      nulled == null && (nulled = true);
      ref$ = this.ctx, added = ref$.added, moved = ref$.moved, removed = ref$.removed;
      callAnimationMakers = function(it, nulled){
        var c, oldFrame, newFrame, diff, nil;
        c = this$.children.get(it);
        oldFrame = this$.ctx.rects.get(it);
        newFrame = c.getFrame();
        diff = _.pickBy(_.mapValues(oldFrame, function(v, k){
          return v - newFrame[k];
        }), compose$(Math.abs, (function(it){
          return it > 0.01;
        })));
        if (nulled) {
          nil = {};
          if (diff.top != null) {
            nil.top = 0;
          }
          if (diff.left != null) {
            nil.left = 0;
          }
          if (diff.width != null) {
            nil.width = null;
          }
          if (diff.height != null) {
            nil.height = null;
          }
        } else {
          nil = diff;
        }
        return [c, diff, nil];
      };
      x$ = this.ctx;
      x$.animations = added.map(function(it){
        var ref$;
        return typeof (ref$ = this$.children.get(it)).makeAddAnimation == 'function' ? ref$.makeAddAnimation({}, {}) : void 8;
      }).concat(moved.map(function(it){
        var ref$, c, diff, nil;
        ref$ = callAnimationMakers(it, true), c = ref$[0], diff = ref$[1], nil = ref$[2];
        return typeof c.makeMoveAnimation == 'function' ? c.makeMoveAnimation(diff, nil) : void 8;
      })).concat(removed.map(function(it){
        var ref$, c, diff, nil;
        ref$ = callAnimationMakers(it, false), c = ref$[0], diff = ref$[1], nil = ref$[2];
        return typeof c.makeRemoveAnimation == 'function' ? c.makeRemoveAnimation(diff, nil) : void 8;
      })).filter(function(it){
        return it != null;
      });
      ans = x$.animations.size;
      if (!ans) {
        this.animationsDone(x$);
      } else {
        x$.animationsCount = ans;
        x$.animations.forEach(function(promise){
          promise.then(function(it){
            return it.bind(this$, this$.ctx);
          }(function(ctx){
            if (ctx !== this.ctx) {
              return;
            }
            ctx.animationsCount -= 1;
            if (ctx.animationsCount < 1) {
              this.animationsDone(ctx);
            }
          }));
        });
      }
    },
    animationsDone: function(ctx){
      var that;
      this.setState({
        items: this.ctx.items.skipLast(this.ctx.removed.size)
      });
      this.ctx = null;
      if ((that = this.nextItems) != null) {
        this.nextItems = null;
        return this._itemsReceived(that);
      }
    },
    _itemsReceived: function(items){
      var oldItems;
      if (!(items != null && items !== (oldItems = this.state.items))) {
        return;
      }
      oldItems == null && (oldItems = List());
      if (this.ctx != null || !this.isMounted()) {
        return this.nextItems = items;
      } else {
        return this.animationsInit(items, oldItems);
      }
    },
    componentWillReceiveProps: function(np){
      var ref$;
      if (np.items !== (ref$ = this.props.items) && ref$ !== this.nextItems) {
        this._itemsReceived(np.items);
      }
    },
    componentWillMount: function(){
      return this._itemsReceived(this.props.items);
    },
    componentDidMount: function(){
      var that;
      if ((that = this.nextItems) != null) {
        this.nextItems = null;
        this._itemsReceived(that);
      }
    },
    componentWillUpdate: function(){
      var ref$;
      if ((ref$ = this.ctx) != null) {
        ref$.before && (ref$.before = (this.ctx.before(), null));
      }
    },
    componentDidUpdate: function(){
      var ref$;
      if ((ref$ = this.ctx) != null) {
        ref$.after && (ref$.after = (this.ctx.after(), null));
      }
    },
    render: function(){
      var component, items, this$ = this;
      component = this.props.component;
      items = this.state.items;
      return div({
        className: classes('ani-list', this.props.className)
      }, div({
        className: classes('static container', this.props.itemsClassName),
        ref: function(it){
          this$.staticDom = sodom(it);
        }
      }, items != null ? items.map(function(i){
        var id;
        id = i.get('id');
        return createElement(component, {
          key: id,
          item: i,
          ref: function(it){
            return it.bind(this$, id);
          }(function(id, component){
            if (component != null) {
              this.children.set(id, component);
            } else {
              this.children.remove(id);
            }
          })
        });
      }) : void 8));
    }
  });
  Anilist = React.createFactory(AnilistClass);
  module.exports = {
    AnilistClass: AnilistClass,
    Anilist: Anilist
  };
  function compose$() {
    var functions = arguments;
    return function() {
      var i, result;
      result = functions[0].apply(this, arguments);
      for (i = 1; i < functions.length; ++i) {
        result = functions[i](result);
      }
      return result;
    };
  }
  function bind$(obj, key, target){
    return function(){ return (target || obj)[key].apply(obj, arguments) };
  }
}).call(this);
