(function(){
  var _, SodomNode;
  _ = require('lodash');
  SodomNode = (function(){
    SodomNode.displayName = 'SodomNode';
    var prototype = SodomNode.prototype, constructor = SodomNode;
    function SodomNode(node){
      this.node = node;
    }
    SodomNode.prototype.top = function(){
      var ref$;
      return (ref$ = this.node.offsetTop) != null
        ? ref$
        : this.node.clientTop;
    };
    SodomNode.prototype.left = function(){
      var ref$;
      return (ref$ = this.node.offsetLeft) != null
        ? ref$
        : this.node.clientLeft;
    };
    SodomNode.prototype.height = function(){
      var ref$;
      return (ref$ = this.node.offsetHeight) != null
        ? ref$
        : this.node.clientHeight;
    };
    SodomNode.prototype.width = function(){
      var ref$;
      return (ref$ = this.node.offsetWidth) != null
        ? ref$
        : this.node.clientWidth;
    };
    SodomNode.prototype.bottom = function(){
      return this.top() + this.height();
    };
    SodomNode.prototype.right = function(){
      return this.left() + this.width();
    };
    SodomNode.prototype.clone = function(){
      return this.node.cloneNode(true);
    };
    SodomNode.prototype.clear = function(){
      return Array.prototype.slice.apply(this.node.children).map(bind$(this.node, 'removeChild'));
    };
    SodomNode.prototype.margins = function(){
      var cs, this$ = this;
      if (document.all) {
        return [
          function(it){
            return it.marginTop;
          }, function(it){
            return it.marginRight;
          }, function(it){
            return it.marginBottom;
          }, function(it){
            return it.marginLeft;
          }
        ].map(function(it){
          return parseInt(it(
          this$.node.currentStyle), 10);
        });
      } else {
        cs = document.defaultView.getComputedStyle(this.node, '');
        return ['margin-top', 'margin-right', 'margin-bottom', 'margin-left'].map(compose$(bind$(cs, 'getPropertyValue'), parseInt));
      }
    };
    SodomNode.prototype.computedStyle = function(keys){
      var gpv, cs;
      gpv = (cs = document.defaultView.getComputedStyle(this.node, '')).getPropertyValue.bind(cs);
      return _.fromPairs(keys.map(function(it){
        return [it, gpv(it)];
      }));
    };
    SodomNode.prototype.getFullRect = function(){
      var ref$, mt, mr, mb, ml;
      ref$ = this.margins(), mt = ref$[0], mr = ref$[1], mb = ref$[2], ml = ref$[3];
      return {
        left: (ref$ = this.node.getBoundingClientRect()).left,
        top: ref$.top,
        width: ref$.width,
        height: ref$.height
      };
    };
    SodomNode.prototype.getRelativeRect = function(){
      var ref$, ref1$;
      return ref$ = {
        width: (ref1$ = this.node.getBoundingClientRect()).width,
        height: ref1$.height
      }, ref$.top = this.top(), ref$.left = this.left(), ref$;
    };
    SodomNode.prototype.updateStyle = function(){
      var i$, len$, a;
      for (i$ = 0, len$ = (arguments).length; i$ < len$; ++i$) {
        a = (arguments)[i$];
        import$(this.node.style, a);
      }
      return this;
    };
    return SodomNode;
  }());
  module.exports = function(node){
    if (node != null) {
      return new SodomNode(node);
    }
  };
  function bind$(obj, key, target){
    return function(){ return (target || obj)[key].apply(obj, arguments) };
  }
  function compose$() {
    var functions = arguments;
    return function() {
      var i, result;
      result = functions[0].apply(this, arguments);
      for (i = 1; i < functions.length; ++i) {
        result = functions[i](result);
      }
      return result;
    };
  }
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
